// tranceiverDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tranceiver.h"
#include "tranceiverDlg.h"
#include "math.h"
#include "conio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


double offset = 0;



/////////////////////////////////////////////////////////////////////////////
// CTranceiverDlg dialog


CTranceiverDlg::CTranceiverDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTranceiverDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTranceiverDlg)
	m_frequency = 0;
	m_rcvrfrequency = 0.0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTranceiverDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTranceiverDlg)
	DDX_Text(pDX, IDC_EDIT1, m_frequency);
	DDX_Text(pDX, IDC_EDIT2, m_rcvrfrequency);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTranceiverDlg, CDialog)
	//{{AFX_MSG_MAP(CTranceiverDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
    ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTranceiverDlg message handlers

BOOL CTranceiverDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTranceiverDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTranceiverDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTranceiverDlg::OnButton5()//transmitter frequency enter button 
{
	// TODO: Add your control notification handler code here
UpdateData(TRUE);
	// Calculate frequency number - formula is given by manufacturer.
	double freq=m_frequency;
    double freqcnst= pow(2,32)/50000000;
    unsigned int freqnumber=freq*freqcnst;
    //break frequency number into four bytes.
	unsigned int fmask=255;
     //data1 is the least significant byte
	unsigned int data1=(freqnumber & fmask);

	unsigned int datashift=_rotr(freqnumber,8);

	unsigned int data2=(datashift & fmask);

	datashift=_rotr(freqnumber,16);
	
	unsigned int data3=(datashift & fmask);

    datashift=_rotr(freqnumber,24);
    
	//data4 is the most significant byte
	
	unsigned int data4=(datashift & fmask);

	//Send bytes to output port.
    
	
	
	_outp(0x37A,3);//reset
        
	_outp(0x37A,4);//restore

	_outp(0x378,data4);

    _outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data3);
	
	_outp(0x37A,5);//latch
	
	_outp(0x37A,4);//restore

	_outp(0x378,3);//f1_highselect

	_outp(0x37A,12);//write
	
	_outp(0x37A,4);//restore

	_outp(0x378,data2);

	_outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data1);

	_outp(0x37A,5);//latch

	_outp(0x37A,4);//restore

	_outp(0x378,2);//f1_lowselect

	_outp(0x37A,12);//write

	_outp(0x37A,4);//restore

	
}

void CTranceiverDlg::OnButton1() //transmitter up button
{
	// TODO: Add your control notification handler code here
    
	m_frequency=m_frequency + 100;
	
    UpdateData(FALSE);

	double freq=m_frequency;
    double freqcnst= pow(2,32)/50000000;
    unsigned int freqnumber=freq*freqcnst;
    //break frequency number into four bytes.
	unsigned int fmask=255;
     //data1 is the least significant byte
	unsigned int data1=(freqnumber & fmask);

	unsigned int datashift=_rotr(freqnumber,8);

	unsigned int data2=(datashift & fmask);

	datashift=_rotr(freqnumber,16);
	
	unsigned int data3=(datashift & fmask);

    datashift=_rotr(freqnumber,24);
    
	//data4 is the most significant byte
	
	unsigned int data4=(datashift & fmask);

	//Send bytes to output port.
    
	
	
	_outp(0x37A,3);//reset
        
	_outp(0x37A,4);//restore

	_outp(0x378,data4);

    _outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data3);
	
	_outp(0x37A,5);//latch
	
	_outp(0x37A,4);//restore

	_outp(0x378,3);//f1_highselect

	_outp(0x37A,12);//write
	
	_outp(0x37A,4);//restore

	_outp(0x378,data2);

	_outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data1);

	_outp(0x37A,5);//latch

	_outp(0x37A,4);//restore

	_outp(0x378,2);//f1_lowselect

	_outp(0x37A,12);//write

	_outp(0x37A,4);//restore






}

void CTranceiverDlg::OnButton2()//transmitter down button
{


    m_frequency=m_frequency -100;
	
    UpdateData(FALSE);
	double freq=m_frequency;
    double freqcnst= pow(2,32)/50000000;
    unsigned int freqnumber=freq*freqcnst;
    //break frequency number into four bytes.
	unsigned int fmask=255;
     //data1 is the least significant byte
	unsigned int data1=(freqnumber & fmask);

	unsigned int datashift=_rotr(freqnumber,8);

	unsigned int data2=(datashift & fmask);

	datashift=_rotr(freqnumber,16);
	
	unsigned int data3=(datashift & fmask);

    datashift=_rotr(freqnumber,24);
    
	//data4 is the most significant byte
	
	unsigned int data4=(datashift & fmask);

	//Send bytes to output port.
    
	
	
	_outp(0x37A,3);//reset
        
	_outp(0x37A,4);//restore

	_outp(0x378,data4);

    _outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data3);
	
	_outp(0x37A,5);//latch
	
	_outp(0x37A,4);//restore

	_outp(0x378,3);//f1_highselect

	_outp(0x37A,12);//write
	
	_outp(0x37A,4);//restore

	_outp(0x378,data2);

	_outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data1);

	_outp(0x37A,5);//latch

	_outp(0x37A,4);//restore

	_outp(0x378,2);//f1_lowselect

	_outp(0x37A,12);//write

	_outp(0x37A,4);//restore



}

void CTranceiverDlg::OnRadio1() //40 meters
{
	// TODO: Add your control notification handler code here

    m_rcvrfrequency = 7025000;

	offset = 3999100;

UpdateData(FALSE);
	double freq=m_rcvrfrequency + offset;
    double freqcnst= pow(2,32)/50000000;
    unsigned int freqnumber=freq*freqcnst;
    //break frequency number into four bytes.
	unsigned int fmask=255;
     //data1 is the least significant byte
	unsigned int data1=(freqnumber & fmask);

	unsigned int datashift=_rotr(freqnumber,8);

	unsigned int data2=(datashift & fmask);

	datashift=_rotr(freqnumber,16);
	
	unsigned int data3=(datashift & fmask);

    datashift=_rotr(freqnumber,24);
    
	//data4 is the most significant byte
	
	unsigned int data4=(datashift & fmask);

	//Send bytes to output port.
    
	
	
	_outp(0x37A,3);//reset
        
	_outp(0x37A,4);//restore

	_outp(0x378,data4);

    _outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data3);
	
	_outp(0x37A,5);//latch
	
	_outp(0x37A,4);//restore

	_outp(0x378,1);//f0_highselect

	_outp(0x37A,12);//write
	
	_outp(0x37A,4);//restore

	_outp(0x378,data2);

	_outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data1);

	_outp(0x37A,5);//latch

	_outp(0x37A,4);//restore

	_outp(0x378,0);//f0_lowselect

	_outp(0x37A,12);//write

	_outp(0x37A,4);//restore




}

void CTranceiverDlg::OnRadio2() //30 meters
{
	// TODO: Add your control notification handler code here

 m_rcvrfrequency = 10103000;

	offset = -3999100;

UpdateData(FALSE);
	double freq=m_rcvrfrequency + offset;
    double freqcnst= pow(2,32)/50000000;
    unsigned int freqnumber=freq*freqcnst;
    //break frequency number into four bytes.
	unsigned int fmask=255;
     //data1 is the least significant byte
	unsigned int data1=(freqnumber & fmask);

	unsigned int datashift=_rotr(freqnumber,8);

	unsigned int data2=(datashift & fmask);

	datashift=_rotr(freqnumber,16);
	
	unsigned int data3=(datashift & fmask);

    datashift=_rotr(freqnumber,24);
    
	//data4 is the most significant byte
	
	unsigned int data4=(datashift & fmask);

	//Send bytes to output port.
    
	
	
	_outp(0x37A,3);//reset
        
	_outp(0x37A,4);//restore

	_outp(0x378,data4);

    _outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data3);
	
	_outp(0x37A,5);//latch
	
	_outp(0x37A,4);//restore

	_outp(0x378,1);//f0_highselect

	_outp(0x37A,12);//write
	
	_outp(0x37A,4);//restore

	_outp(0x378,data2);

	_outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data1);

	_outp(0x37A,5);//latch

	_outp(0x37A,4);//restore

	_outp(0x378,0);//f0_lowselect

	_outp(0x37A,12);//write

	_outp(0x37A,4);//restore




}
	
void CTranceiverDlg::OnRadio3()//20 meters 
{
	// TODO: Add your control notification handler code here
	
 m_rcvrfrequency = 14025000;

    offset = -3999100;

UpdateData(FALSE);
	double freq=m_rcvrfrequency + offset;
    double freqcnst= pow(2,32)/50000000;
    unsigned int freqnumber=freq*freqcnst;
    //break frequency number into four bytes.
	unsigned int fmask=255;
     //data1 is the least significant byte
	unsigned int data1=(freqnumber & fmask);

	unsigned int datashift=_rotr(freqnumber,8);

	unsigned int data2=(datashift & fmask);

	datashift=_rotr(freqnumber,16);
	
	unsigned int data3=(datashift & fmask);

    datashift=_rotr(freqnumber,24);
    
	//data4 is the most significant byte
	
	unsigned int data4=(datashift & fmask);

	//Send bytes to output port.
    
	
	
	_outp(0x37A,3);//reset
        
	_outp(0x37A,4);//restore

	_outp(0x378,data4);

    _outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data3);
	
	_outp(0x37A,5);//latch
	
	_outp(0x37A,4);//restore

	_outp(0x378,1);//f0_highselect

	_outp(0x37A,12);//write
	
	_outp(0x37A,4);//restore

	_outp(0x378,data2);

	_outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data1);

	_outp(0x37A,5);//latch

	_outp(0x37A,4);//restore

	_outp(0x378,0);//f0_lowselect

	_outp(0x37A,12);//write

	_outp(0x37A,4);//restore




}


void CTranceiverDlg::OnRadio4()//15 meters 
{
	// TODO: Add your control notification handler code here
	
 m_rcvrfrequency = 21025000;

    offset = -3999100;

UpdateData(FALSE);
	double freq=m_rcvrfrequency + offset;
    double freqcnst= pow(2,32)/50000000;
    unsigned int freqnumber=freq*freqcnst;
    //break frequency number into four bytes.
	unsigned int fmask=255;
     //data1 is the least significant byte
	unsigned int data1=(freqnumber & fmask);

	unsigned int datashift=_rotr(freqnumber,8);

	unsigned int data2=(datashift & fmask);

	datashift=_rotr(freqnumber,16);
	
	unsigned int data3=(datashift & fmask);

    datashift=_rotr(freqnumber,24);
    
	//data4 is the most significant byte
	
	unsigned int data4=(datashift & fmask);

	//Send bytes to output port.
    
	
	
	_outp(0x37A,3);//reset
        
	_outp(0x37A,4);//restore

	_outp(0x378,data4);

    _outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data3);
	
	_outp(0x37A,5);//latch
	
	_outp(0x37A,4);//restore

	_outp(0x378,1);//f0_highselect

	_outp(0x37A,12);//write
	
	_outp(0x37A,4);//restore

	_outp(0x378,data2);

	_outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data1);

	_outp(0x37A,5);//latch

	_outp(0x37A,4);//restore

	_outp(0x378,0);//f0_lowselect

	_outp(0x37A,12);//write

	_outp(0x37A,4);//restore




}







void CTranceiverDlg::OnButton6() //rcvr enter button
{
	// TODO: Add your control notification handler code here

 
    UpdateData(TRUE);
	double freq=m_rcvrfrequency + offset;

	double freqcnst= pow(2,32)/50000000;
    unsigned int freqnumber=freq*freqcnst;
    //break frequency number into four bytes.
	unsigned int fmask=255;
     //data1 is the least significant byte
	unsigned int data1=(freqnumber & fmask);

	unsigned int datashift=_rotr(freqnumber,8);

	unsigned int data2=(datashift & fmask);

	datashift=_rotr(freqnumber,16);
	
	unsigned int data3=(datashift & fmask);

    datashift=_rotr(freqnumber,24);
    
	//data4 is the most significant byte
	
	unsigned int data4=(datashift & fmask);

	//Send bytes to output port.
    
	
	
	_outp(0x37A,3);//reset
        
	_outp(0x37A,4);//restore

	_outp(0x378,data4);

    _outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data3);
	
	_outp(0x37A,5);//latch
	
	_outp(0x37A,4);//restore

	_outp(0x378,1);//f0_highselect

	_outp(0x37A,12);//write
	
	_outp(0x37A,4);//restore

	_outp(0x378,data2);

	_outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data1);

	_outp(0x37A,5);//latch

	_outp(0x37A,4);//restore

	_outp(0x378,0);//f0_lowselect

	_outp(0x37A,12);//write

	_outp(0x37A,4);//restore




	



}

void CTranceiverDlg::OnButton3() //receiver up button
{
	// TODO: Add your control notification handler code here
	
 UpdateData(TRUE);
	
	double freq=m_rcvrfrequency;

	m_rcvrfrequency = m_rcvrfrequency + 100;

UpdateData(FALSE);
	freq=m_rcvrfrequency + offset;
    double freqcnst= pow(2,32)/50000000;
    unsigned int freqnumber=freq*freqcnst;
    //break frequency number into four bytes.
	unsigned int fmask=255;
     //data1 is the least significant byte
	unsigned int data1=(freqnumber & fmask);

	unsigned int datashift=_rotr(freqnumber,8);

	unsigned int data2=(datashift & fmask);

	datashift=_rotr(freqnumber,16);
	
	unsigned int data3=(datashift & fmask);

    datashift=_rotr(freqnumber,24);
    
	//data4 is the most significant byte
	
	unsigned int data4=(datashift & fmask);

	//Send bytes to output port.
    
	
	
	_outp(0x37A,3);//reset
        
	_outp(0x37A,4);//restore

	_outp(0x378,data4);

    _outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data3);
	
	_outp(0x37A,5);//latch
	
	_outp(0x37A,4);//restore

	_outp(0x378,1);//f0_highselect

	_outp(0x37A,12);//write
	
	_outp(0x37A,4);//restore

	_outp(0x378,data2);

	_outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data1);

	_outp(0x37A,5);//latch

	_outp(0x37A,4);//restore

	_outp(0x378,0);//f0_lowselect

	_outp(0x37A,12);//write

	_outp(0x37A,4);//restore






}

void CTranceiverDlg::OnButton4()//receiver down button 
{
	// TODO: Add your control notification handler code here

 
UpdateData(TRUE);

    m_rcvrfrequency = m_rcvrfrequency -100;

UpdateData(FALSE);    
    

    double freq=m_rcvrfrequency + offset;

    double freqcnst= pow(2,32)/50000000;
    
	unsigned int freqnumber=freq*freqcnst;
    //break frequency number into four bytes.
	unsigned int fmask=255;
     //data1 is the least significant byte
	unsigned int data1=(freqnumber & fmask);

	unsigned int datashift=_rotr(freqnumber,8);

	unsigned int data2=(datashift & fmask);

	datashift=_rotr(freqnumber,16);
	
	unsigned int data3=(datashift & fmask);

    datashift=_rotr(freqnumber,24);
    
	//data4 is the most significant byte
	
	unsigned int data4=(datashift & fmask);

	//Send bytes to output port.
    
	
	
	_outp(0x37A,3);//reset
        
	_outp(0x37A,4);//restore

	_outp(0x378,data4);

    _outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data3);
	
	_outp(0x37A,5);//latch
	
	_outp(0x37A,4);//restore

	_outp(0x378,1);//f0_highselect

	_outp(0x37A,12);//write
	
	_outp(0x37A,4);//restore

	_outp(0x378,data2);

	_outp(0x37A,0);//load

	_outp(0x37A,4);//restore

	_outp(0x378,data1);

	_outp(0x37A,5);//latch

	_outp(0x37A,4);//restore

	_outp(0x378,0);//f0_lowselect

	_outp(0x37A,12);//write

	_outp(0x37A,4);//restore





	

}
